// TraderSpi.cpp: implementation of the CTraderSpi class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "AutomationDemo.h"
#include "TraderSpi.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CTraderSpi::CTraderSpi()
{
	m_pLog = NULL;
	m_pUserApi = NULL;
	m_nRequestId = 0;
}

CTraderSpi::~CTraderSpi()
{
	if (m_pUserApi)
	{
		m_pUserApi->Release();
		m_pUserApi = NULL;
	}
}

void CTraderSpi::OnFrontConnected()
{
	///û¼
	ReqUserLogin();
}

void CTraderSpi::ReqUserLogin()
{
	CThostFtdcReqUserLoginField req;
	memset(&req, 0, sizeof(req));
	strcpy(req.BrokerID, "3030");
	strcpy(req.UserID, m_pDlg->m_strAccountName);
	strcpy(req.Password, m_pDlg->m_strPassword);
	int iResult = m_pUserApi->ReqUserLogin(&req, ++m_nRequestId);
	if (iResult == 0)
	{
		FormatLog(LOG_APP_LEVEL, "ReqUserLogin", "½ɹ");
	}
	else
	{
		FormatLog(LOG_ERROR_LEVEL, "ReqUserLogin", "ʧ");
		m_pDlg->PostMessage(WM_MSG_LOGIN_FAILURE);
	}
}

void CTraderSpi::OnRspUserLogin( CThostFtdcRspUserLoginField *pRspUserLogin, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	if (bIsLast && !IsErrorRspInfo(pRspInfo))
	{
		m_frontID = pRspUserLogin->FrontID;
		m_sessionID = pRspUserLogin->SessionID;
		int iNextOrderRef = atoi(pRspUserLogin->MaxOrderRef);
		iNextOrderRef++;
		sprintf(m_orderRef, "%d", iNextOrderRef);
		FormatLog(LOG_APP_LEVEL, "OnRspUserLogin", "User Login success");
		m_pDlg->PostMessage(WM_MSG_LOGIN_SUCCESS);
	}
	else
	{
		CString strFormat;
		strFormat.Format("User Login Failure ErrCode:%d, ErrMsg:%s", pRspInfo->ErrorID, pRspInfo->ErrorMsg);
		FormatLog(LOG_APP_LEVEL, "OnRspUserLogin", strFormat);
		CThostFtdcRspInfoField *pRspField = new CThostFtdcRspInfoField;
		memcpy(pRspField, pRspInfo, sizeof(CThostFtdcRspInfoField));
		m_pDlg->PostMessage(WM_MSG_LOGIN_FAILURE, (WPARAM)pRspField);
	}
}

void CTraderSpi::OnRspSettlementInfoConfirm( CThostFtdcSettlementInfoConfirmField *pSettlementInfoConfirm, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	
}

void CTraderSpi::OnRspQryInstrument( CThostFtdcInstrumentField *pInstrument, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	
}

void CTraderSpi::OnRspQryTradingAccount( CThostFtdcTradingAccountField *pTradingAccount, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	
}

void CTraderSpi::OnRspQryInvestorPosition( CThostFtdcInvestorPositionField *pInvestorPosition, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	
}

void CTraderSpi::ReqOrderInsert(char* chInstrment, double price, char offsetFlag, char direction, int volumn)
{
	CThostFtdcInputOrderField req;
	memset(&req, 0, sizeof(req));
	///͹˾
	strcpy(req.BrokerID, "3030");
	///Ͷߴ
	strcpy(req.InvestorID, m_pDlg->m_strAccountName);
	///Լ
	strcpy(req.InstrumentID, chInstrment);
	///
	strcpy(req.OrderRef, m_orderRef);
	///û
	//	TThostFtdcUserIDType	UserID;
	///۸: ޼
	//req.OrderPriceType = THOST_FTDC_OPT_LimitPrice;
	req.OrderPriceType = THOST_FTDC_OPT_AnyPrice;
	///: 
	req.Direction = direction;
	///Ͽƽ־: 
	req.CombOffsetFlag[0] = offsetFlag;
	///Ͷױ־
	req.CombHedgeFlag[0] = THOST_FTDC_HF_Speculation;
	///۸
	req.LimitPrice = price;
	///: 1
	req.VolumeTotalOriginal = volumn;
	///Ч: Ч
	req.TimeCondition = THOST_FTDC_TC_GFD;
	///GTD
	//	TThostFtdcDateType	GTDDate;
	///ɽ: κ
	req.VolumeCondition = THOST_FTDC_VC_AV;
	///Сɽ: 1
	req.MinVolume = 1;
	///: 
	req.ContingentCondition = THOST_FTDC_CC_Immediately;
	///ֹ
	//	TThostFtdcPriceType	StopPrice;
	///ǿƽԭ: ǿƽ
	req.ForceCloseReason = THOST_FTDC_FCC_NotForceClose;
	///Զ־: 
	req.IsAutoSuspend = 0;
	///ҵԪ
	//	TThostFtdcBusinessUnitType	BusinessUnit;
	///
	//	TThostFtdcRequestIDType	RequestID;
	///ûǿ־: 
	req.UserForceClose = 0;
	
	int iResult = m_pUserApi->ReqOrderInsert(&req, ++m_nRequestId);
}

///󱨵¼(ûµ)
void CTraderSpi::OnRspOrderInsert( CThostFtdcInputOrderField *pInputOrder, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	if (IsErrorRspInfo(pRspInfo))
	{
		CString strTmp;
		strTmp.Format("Error response errCode:%d, errMsg:%s", pRspInfo->ErrorID, pRspInfo->ErrorMsg);
		FormatLog(LOG_ERROR_LEVEL, "OnRspOrderInsert", strTmp);
	}
	else
	{
		FormatLog(LOG_APP_LEVEL, "OnRspOrderInsert", "Sucess");	
	}
}

void CTraderSpi::ReqOrderAction( CThostFtdcInputOrderActionField *pOrder )
{
	int iResult = m_pUserApi->ReqOrderAction(pOrder, ++m_nRequestId);
}

void CTraderSpi::OnRspOrderAction( CThostFtdcInputOrderActionField *pInputOrderAction, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	if (pRspInfo && pRspInfo->ErrorID != 0)
	{
		CString strFor;
		strFor.Format("ʧ:[%d-%s]", pRspInfo->ErrorID, pRspInfo->ErrorMsg);
		FormatLog(LOG_ERROR_LEVEL, "OnRspOrderAction", strFor);
	}
	else
	{
		FormatLog(LOG_APP_LEVEL, "OnRspOrderAction", "Rsp success");
	}
}

void CTraderSpi::OnRspError( CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	
}

void CTraderSpi::OnFrontDisconnected( int nReason )
{
	CString strTmp;
	strTmp.Format("Reason: %d", nReason);
	FormatLog(LOG_APP_LEVEL, "OnFrontDisconnected", strTmp);
}

void CTraderSpi::OnHeartBeatWarning( int nTimeLapse )
{
	
}

void CTraderSpi::OnRtnOrder( CThostFtdcOrderField *pOrder )
{
	FormatLog(LOG_APP_LEVEL, "OnRtnOrder", "Rtn order");
	CThostFtdcOrderField* pNewOrder = new CThostFtdcOrderField;
	memcpy(pNewOrder, pOrder, sizeof(CThostFtdcOrderField));
	m_pDlg->PostMessage(WM_MSG_RTN_ORDER, (WPARAM)pNewOrder);
}

void CTraderSpi::OnRtnTrade( CThostFtdcTradeField *pTrade )
{
	FormatLog(LOG_APP_LEVEL, "OnRtnTrade", "Rtn trade");
	CThostFtdcTradeField* pNewTrade = new CThostFtdcTradeField;
	memcpy(pNewTrade, pTrade, sizeof(CThostFtdcTradeField));
	m_pDlg->PostMessage(WM_MSG_RTN_TRADE, (WPARAM)pNewTrade);
}



void CTraderSpi::ReqSettlementInfoConfirm()
{
	
}

void CTraderSpi::ReqQryInstrument()
{
	
}

void CTraderSpi::ReqQryTradingAccount()
{
	
}

void CTraderSpi::ReqQryInvestorPosition()
{
	
}

bool CTraderSpi::IsErrorRspInfo( CThostFtdcRspInfoField *pRspInfo )
{
	return ((pRspInfo) && (pRspInfo->ErrorID != 0));
}

bool CTraderSpi::IsMyOrder( CThostFtdcOrderField *pOrder )
{
	return ((pOrder->FrontID == m_frontID) &&
		(pOrder->SessionID == m_sessionID) &&
			(strcmp(pOrder->OrderRef, m_orderRef) == 0));
}

bool CTraderSpi::IsTradingOrder( CThostFtdcOrderField *pOrder )
{
	return ((pOrder->OrderStatus != THOST_FTDC_OST_PartTradedNotQueueing) &&
		(pOrder->OrderStatus != THOST_FTDC_OST_Canceled) &&
			(pOrder->OrderStatus != THOST_FTDC_OST_AllTraded));
}

void CTraderSpi::FormatLog( int nLevel, CString strDomain, CString strText )
{
	CString strLog, strTmp;
	SYSTEMTIME nowTime;
	GetLocalTime(&nowTime);
	strLog.Format("%d-%02d-%02d %02d:%02d:%02d %03d   ", nowTime.wYear, nowTime.wMonth, nowTime.wDay, nowTime.wHour, nowTime.wMinute, nowTime.wSecond, nowTime.wMilliseconds);
	switch(nLevel)
	{
	case LOG_APP_LEVEL:
		strTmp.Format("CTraderSpi::%s\t [Info] %s", strDomain, strText);
		break;
	case LOG_DEBUG_LEVEL:
		strTmp.Format("CTraderSpi::%s\t [Debug] %s", strDomain, strText);
		break;
	case LOG_WARN_LEVEL:
		strTmp.Format("CTraderSpi::%s\t [Warn] %s", strDomain, strText);
		break;
	case LOG_ERROR_LEVEL:
		strTmp.Format("CTraderSpi::%s\t [Err] %s", strDomain, strText);
		break;
	}
	if (m_pLog)
	{
		strLog += strTmp;
		fprintf(m_pLog, "%s\n", strLog);
		fflush(m_pLog);
	}
}

void CTraderSpi::Init( FILE* pLog, char* szAddress )
{
	m_pLog = pLog;
	if (m_pUserApi == NULL)
	{
		m_pUserApi = CThostFtdcTraderApi::CreateFtdcTraderApi();
		m_pUserApi->RegisterSpi(this);
		m_pUserApi->RegisterFront(szAddress);
		m_pUserApi->Init();
	}
}

void CTraderSpi::ReqQryInvestorPositionDetail(CThostFtdcQryInvestorPositionDetailField *pQryInvestorPositionDetail)
{
	m_pUserApi->ReqQryInvestorPositionDetail(pQryInvestorPositionDetail, ++m_nRequestId);
}

void CTraderSpi::OnRspQryInvestorPositionDetail( CThostFtdcInvestorPositionDetailField *pInvestorPositionDetail, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	if (pRspInfo && pRspInfo->ErrorID != 0)
	{
		FormatLog(LOG_ERROR_LEVEL, "OnRspQryInvestorPositionDetail", pRspInfo->ErrorMsg);
	}
	else
	{
		CString strFormat;
		strFormat.Format("Date:%s, Flag:%s, Ins:%s, volume:%d, price:%.2lf", pInvestorPositionDetail->TradingDay, 
			pInvestorPositionDetail->Direction == THOST_FTDC_D_Buy ? "":"ղ", pInvestorPositionDetail->InstrumentID, 
			pInvestorPositionDetail->Volume, pInvestorPositionDetail->OpenPrice);
		FormatLog(LOG_APP_LEVEL, "OnRspQryInvestorPositionDetail", strFormat);
	}
	if (bIsLast)
	{
		FormatLog(LOG_APP_LEVEL, "OnRspQryInvestorPositionDetail", "Query done");
	}
}

void CTraderSpi::ReqQryOrder( CThostFtdcQryOrderField *pQryOrder )
{
	int iResult = m_pUserApi->ReqQryOrder(pQryOrder, ++m_nRequestId);
	if (iResult != 0)
	{
		FormatLog(LOG_APP_LEVEL, "ReqQryOrder", "ѯʧ");
	}
}

void CTraderSpi::OnRspQryOrder( CThostFtdcOrderField *pOrder, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	if (pRspInfo && pRspInfo != 0)
	{
		CString strText;
		strText.Format("ErrorID:%d, ErrMsg:%s", pRspInfo->ErrorID, pRspInfo->ErrorMsg);
		FormatLog(LOG_APP_LEVEL, "RspOrder", strText);
	}
	else
	{
		if (pOrder->OrderStatus == '1' || pOrder->OrderStatus == '3' || pOrder->OrderStatus == 'b')
		{
			CThostFtdcOrderField* pNewOrder = new CThostFtdcOrderField;
			memcpy(pNewOrder, pOrder, sizeof(CThostFtdcOrderField));
			m_pDlg->AddNewUntradeOrder(pNewOrder, false);
		}
		if (bIsLast)
		{
			m_pDlg->AddNewUntradeOrder(NULL, true);
		}
	}
}



