// TraderSpi.h: interface for the CTraderSpi class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRADERSPI_H__43862588_D1C0_4AB9_9356_68D1900AB786__INCLUDED_)
#define AFX_TRADERSPI_H__43862588_D1C0_4AB9_9356_68D1900AB786__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "./ThostTraderApi/ThostFtdcTraderApi.h"
#include "AutomationDemoDlg.h"

class CAutomationDemoDlg;
class CTraderSpi : public CThostFtdcTraderSpi
{
public:
	CTraderSpi();
	~CTraderSpi();
	void Init(FILE* pLog, char* szAddress);
	void SetRspDlg(CAutomationDemoDlg* pDlg) { m_pDlg = pDlg; }
public:
	///ͻ뽻׺̨ͨʱδ¼ǰ÷á
	virtual void OnFrontConnected();
	
	///¼Ӧ
	virtual void OnRspUserLogin(CThostFtdcRspUserLoginField *pRspUserLogin,	CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	
	///Ͷ߽ȷӦ
	virtual void OnRspSettlementInfoConfirm(CThostFtdcSettlementInfoConfirmField *pSettlementInfoConfirm, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	
	///ѯԼӦ
	virtual void OnRspQryInstrument(CThostFtdcInstrumentField *pInstrument, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	
	///ѯʽ˻Ӧ
	virtual void OnRspQryTradingAccount(CThostFtdcTradingAccountField *pTradingAccount, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	
	///ѯͶֲ߳Ӧ
	virtual void OnRspQryInvestorPosition(CThostFtdcInvestorPositionField *pInvestorPosition, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	
	///¼Ӧ
	virtual void OnRspOrderInsert(CThostFtdcInputOrderField *pInputOrder, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	
	///Ӧ
	virtual void OnRspOrderAction(CThostFtdcInputOrderActionField *pInputOrderAction, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	
	///Ӧ
	virtual void OnRspError(CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	
	///ͻ뽻׺̨ͨӶϿʱ÷áAPIԶӣͻ˿ɲ
	virtual void OnFrontDisconnected(int nReason);
	
	///ʱ档ʱδյʱ÷á
	virtual void OnHeartBeatWarning(int nTimeLapse);
	
	///֪ͨ
	virtual void OnRtnOrder(CThostFtdcOrderField *pOrder);
	
	///ɽ֪ͨ
	virtual void OnRtnTrade(CThostFtdcTradeField *pTrade);

	///ѯͶֲ߳ϸӦ
	virtual void OnRspQryInvestorPositionDetail(CThostFtdcInvestorPositionDetailField *pInvestorPositionDetail, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);

	///ѯر
	virtual void OnRspQryOrder(CThostFtdcOrderField *pOrder, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
public:
	///û¼
	void ReqUserLogin();
	///Ͷ߽ȷ
	void ReqSettlementInfoConfirm();
	///ѯԼ
	void ReqQryInstrument();
	///ѯʽ˻
	void ReqQryTradingAccount();
	///ѯͶֲ߳
	void ReqQryInvestorPosition();
	///ѯͶֲ߳ϸ
	void ReqQryInvestorPositionDetail(CThostFtdcQryInvestorPositionDetailField *pQryInvestorPositionDetail);
	///¼
	void ReqOrderInsert(char* chInstrment, double price, char offsetFlag, char direction, int volumn);
	///
	void ReqOrderAction(CThostFtdcInputOrderActionField *pOrder);
	///󱨵
	void ReqQryOrder(CThostFtdcQryOrderField *pQryOrder);
private:
	// ǷյɹӦ
	bool IsErrorRspInfo(CThostFtdcRspInfoField *pRspInfo);
	// Ƿҵıر
	bool IsMyOrder(CThostFtdcOrderField *pOrder);
	// Ƿڽ׵ı
	bool IsTradingOrder(CThostFtdcOrderField *pOrder);

	///־
	void FormatLog(int nLevel, CString strDomain, CString strText);
private:
	///Ի
	CAutomationDemoDlg*			m_pDlg;
	///ͨŵAPI
	CThostFtdcTraderApi*		m_pUserApi;
	///ǰñ
	TThostFtdcFrontIDType		m_frontID;
	///Ự
	TThostFtdcSessionIDType		m_sessionID;
	///
	TThostFtdcOrderRefType		m_orderRef;
	///û
	TThostFtdcInvestorIDType	m_user;
	///
	TThostFtdcPasswordType		m_password;
	///־
	FILE*						m_pLog;
	///
	int							m_nRequestId;
};

#endif // !defined(AFX_TRADERSPI_H__43862588_D1C0_4AB9_9356_68D1900AB786__INCLUDED_)
